
# if {[string match {*b[0-9]*} [version]] && ![file exists "Powerpete:C"]} {
# 	alertnote "This is a BETA version of Alpha. Do NOT redistribute!"
# }


#if {[regexp {[]\(\)\"\{\}\[]} $HOME]} {alertnote "Alpha may not work properly if it's pathname includes parenthesis, square brackets, double quotes, or curly braces."}
# Get name Alpha's current name.
foreach p [processes] {
	if {[lindex $p 1] == "ALFA"} {
		set ALPHA [lindex $p 0]
		break
	}
}


# Icon menu names. The number refers to the resource id of the #ics family.
#set fsetMenuName 	"SetFiles"
set fsetMenuName 	"131"
set helpMenu		"130"
set cwarriorMenu	"268"
set cwdebugMenu		"274"
set latexMenu		"270"
set perlMenu 		"132"
set tclMenu			"269"
set terrMenu		"271"
set thinkMenu 		"300"
set thinkRefMenu	"265"
set toolboxRefMenu	"400"
set toolserverMenu	"133"
set htmlMenu		"135"
set winMenu 		"263"

# A few definitions I'll need later.
proc quoteExpr str {
	regsub -all {\\} $str {\\\\} str
	regsub -all {\|} $str {\|} str
	regsub -all {\*} $str {\\*} str
	regsub -all {\+} $str {\\+} str
	regsub -all {\(} $str {\\(} str
	regsub -all {\)} $str {\\)} str
	regsub -all {\[} $str {\\[} str
	regsub -all {\]} $str {\\]} str
	return $str
}

proc quoteExpr2 str {
	regsub -all {\\} $str {\\\\} str
	regsub -all {\|} $str {\|} str
	regsub -all {\*} $str {\\*} str
	regsub -all {\+} $str {\\+} str
	regsub -all {\(} $str {\\(} str
	regsub -all {\)} $str {\\)} str
	regsub -all {\{} $str "\\\{" str
	regsub -all {\}} $str "\\\}" str
	regsub -all {\[} $str {\\[} str
	regsub -all {\]} $str {\\]} str
	return $str
}

set auto_path [list $HOME:Tcl:SystemCode $HOME:Tcl:UserCode]
source "$HOME:Tcl:SystemCode:library.tcl"

source "$HOME:Tcl:SystemCode:menus.tcl"
source "$HOME:Tcl:SystemCode:keyBindings.tcl"
source "$HOME:Tcl:SystemCode:definitions.tcl"
source "$HOME:Tcl:SystemCode:procs.tcl"
source "$HOME:Tcl:SystemCode:flags.tcl"
source "$HOME:Tcl:SystemCode:modes.tcl"
source "$HOME:Tcl:SystemCode:filesets.tcl"
source "$HOME:Tcl:SystemCode:copyRing.tcl"

catch {source "$HOME:Tcl:SystemCode:latexMode.tcl"}
catch {source "$HOME:Tcl:SystemCode:bibtexMode.tcl"}
catch {source "$HOME:Tcl:SystemCode:MacPerlmode.tcl"}
catch {source "$HOME:Tcl:SystemCode:htmlMode.tcl"}

# Bogus, but needs to be before userStartup read.
set cwSig MMCC
set cwdSig MWDB

set useEmacs 1

# Read both scalar and array definitions from preferences folder.
catch {readUserDefs}

# After userprefs read.
source "$HOME:Tcl:SystemCode:emacs.tcl"

# Should be last so all filesets make it in.
message "Building filesets..."

rebuildFilesetMenu

buildRecentFiles

set modes [lsort $modes]
buildFlagsVars

if {![info exists readReadme] || ($readReadme < [string trim [lindex [version] 2] {,}])} {
	addDef readReadme [string trim [lindex [version] 2] {,}]
	edit -r "$HOME:Help:Readme"
} else {unset readReadme}


source "$HOME:Tcl:SystemCode:paths.tcl"

setupPrintMenu

# "Switch To" submenu...
buildSwitches

message "Initialization Complete"

