
set tileWidth [expr $screenWidth - 10]
if {$tileWidth > 510} {set defWidth 510} else {set defWidth $tileWidth }
set tileHeight [expr $screenHeight - 60]
set defHeight $tileHeight

set mar 22
set errorHeight [expr (($tileHeight - $mar) / 3)]
set errorDisp [expr (2 * ($tileHeight - $mar)) / 3]
unset mar

set tclvars {}

set allFlags ""
set allVars ""


# The following three procs, together w/ the initialization 
# for the flags below, allow a totally Tcl-controlled menu to 
# shadow Alpha's internal variables.
proc initFlag {var {val ""}} {
	global $var modeVars tclvars allFlags
	if {[lsearch -exact $tclvars $var] < 0} {
		lappend tclvars $var
	}
	linkVar $var
	if {[string length $val]} {set $var $val}
	lappend allFlags $var
}

# Called for ordinary tcl global vars we want included in the Flags menu.
proc initTclFlag {flag {val 0}} {
	global $flag allFlags tclvars modeVars
	if {[lsearch -exact $tclvars $flag] < 0} {
		lappend tclvars $flag
	}
	if {![info exists $flag]} {set $flag $val}
	lappend allFlags $flag
}

# Called for ordinary tcl global vars we want included in the Vars menu.
proc initTclVar {var {val ""}} {
	global $var tclvars modeVars allVars
	if {[lsearch -exact $tclvars $var] < 0} {
		lappend tclvars $var
	}
	if {[string length $val]} {
		set $var $val
	}
	if {![info exists $var]} {set $var 0}
	lappend allVars $var
}

proc initVar {var {val ""}} {
	global $var tclvars modeVars allVars
	if {[lsearch -exact $tclvars $var] < 0} {
		lappend tclvars $var
	}
	linkVar $var
	if {[string length $val]} {
		set $var $val
	}
	lappend allVars $var
}

# This file contains methods allowing the shadowing of tcl variables 

initFlag autoHScroll
initFlag autoSave
initTclFlag backup
initFlag blinkingCursor
initFlag blockCursor
initFlag bwWindows
initFlag coloring
initFlag dragAndDrop
initTclFlag forceMainScreen 1
initFlag horScrollBar 0
initFlag hyperText 1
initTclFlag iconifyOnSwitch
initFlag indentOnCR
initTclFlag infoWindowsDirty 1
initTclFlag intelCutPaste 1
catch {initFlag lockStatus}
initFlag moveInsertion
initFlag noShiftBinding
initFlag openAllFiles
initFlag powerThumb
initFlag projectorAware
initFlag showRowCol
initFlag showInvisibles
initFlag showMode
catch {initFlag showPlatform}
initFlag sortedIsDefault
initFlag tempMem
initFlag undoOn
initFlag wordWrap

initTclVar backExtension "~"
initTclVar backDir
set backDir ""
initVar bottomMargin
initVar changesLim
initVar defaultFont
initVar defHeight
initVar defLeft 	2
initVar defTop 		40
initVar defWidth
initTclVar diffFlags { }
initVar fillColumn
initVar fontSaving
initVar fontSize
initVar funcExpr
initVar funcPar
initVar leftFillColumn
initVar leftMargin
initTclVar numWinsToTile 2
initVar paraColumn
initVar	printerFont
initVar	printerFontSize
initTclFlag printHeader 1
initTclFlag printHeaderTime 1
initTclFlag printHeaderFullPath 0
initVar savedState
initVar sortColumn
initVar tabSize
initVar tagFile
initTclVar tileHeight
initTclVar tileLeft 2
initTclVar tileTop
initTclVar tileWidth
initVar topMargin
initVar wordBreak
initVar wordBreakPreface
initVar	wrapBreak
initVar	wrapBreakPreface

# Flags that won't appear in the menu.
linkVar numLock

# Redefine 'menuHook' to update flags menu.
proc menuHook {} {
	uplevel #0 {
		foreach f $allFlags {
			markMenuItem globalFlags $f [set $f]
		}
	}
}
